public class KNOTEN<T extends AUFLISTBAR> extends ELEMENT<T>{   

    ELEMENT nachfolger;
    T inhalt;

    public KNOTEN(T t) {
        inhalt = t;
        nachfolger = new ABSCHLUSS();
    } 

    public void setzeNachfolger(ELEMENT k) {
        nachfolger = k;
    }

    public ELEMENT nenneNachfolger(){
        return nachfolger;
    }

    public T nenneInhalt() {
        return inhalt;
    } 

    public ELEMENT hintenEinfügen(T t){
        nachfolger = nachfolger.hintenEinfügen(t);
        return this;
    }

    public int gibLänge() {
        return nachfolger.gibLänge() + 1;
    }

    public T entfernenAn(int i) {
        if (i == 1) { 
            T weg; 
            weg = (T) nachfolger.nenneInhalt();
            nachfolger = nachfolger.nenneNachfolger();
            return weg;
        } else {
            return (T) nachfolger.entfernenAn(i-1);
        }
    }

    public boolean einfügenAn(T inhalt, int i) {
        if (i == 1) {
            KNOTEN k;
            k = new KNOTEN(inhalt);
            k.setzeNachfolger(nachfolger);
            nachfolger = k;
            return true;
        } else {
            return nachfolger.einfügenAn(inhalt, i-1);
        }
    }

    public int suchenUndIndexZurückgeben(String info, int i) {
        if (inhalt.info().compareTo(info) == 0) {
            return i;
        } else {
            return nachfolger.suchenUndIndexZurückgeben(info, i+1);
        }
    }
}