public class LISTE<T extends AUFLISTBAR> {   

    ELEMENT anfang;

    public LISTE() { 
        anfang = new ABSCHLUSS();
    }

    public boolean istLeer() {
        if (gibLänge() == 0) {
            return true;
        }
        else {
            return false;
        }
    }

    public void vorneEinfügen(T t) {
        KNOTEN k = new KNOTEN(t); 
        k.setzeNachfolger(anfang); 
        anfang = k;
    } 

    public void hintenEinfügen(T t){ 
        anfang = anfang.hintenEinfügen(t);
    }

    public T vorneEntfernen() {
        T weg; 
        weg = (T) anfang.nenneInhalt();
        anfang = anfang.nenneNachfolger();
        return weg;
    }

    public int gibLänge() {
        return anfang.gibLänge();
    }

    public static LISTE init() {
        LISTE l;
        l=new LISTE<KUNDE>();
        l.hintenEinfügen(new KUNDE("0"));
        l.hintenEinfügen(new KUNDE("1"));
        l.hintenEinfügen(new KUNDE("2"));
        l.hintenEinfügen(new KUNDE("3"));
        l.hintenEinfügen(new KUNDE("4"));
        return l;
    }

    public T entfernenAn(int i) {
        if (i < 0) {
            System.out.println("invalide Stelle");
            return null;
        } else if(i == 0) {
            T weg; 
            weg = (T) anfang.nenneInhalt();
            anfang = anfang.nenneNachfolger();
            return weg;
        }
        else {
            return (T) anfang.entfernenAn(i);
        }
    } 

    public boolean einfügenAn(T inhalt, int i) {
        if (i < 0 ) {
            return false;
        } else if (i == 0) {
            KNOTEN k;
            k = new KNOTEN(inhalt);
            k.setzeNachfolger(anfang);
            anfang = k;
            return true;
        }
        else {
            return anfang.einfügenAn(inhalt, i);
        }
    }  

    public int suchenUndIndexZurückgeben(String info) {
        return anfang.suchenUndIndexZurückgeben(info, 0);
    }
}
