

public class ABSCHLUSS<T extends AUFLISTBAR> extends ELEMENT<T>{
    
    public ABSCHLUSS(){
        //bleibt leer, weil der Abschluss keine Attribute hat
    }
    
    public void setzeNachfolger(ELEMENT k) {
        //bleibt leer, weil der Abschluss keinen Nachfolger hat
    }

    public ELEMENT nenneNachfolger(){
        return this; // Der Abschluss hat sich selbst als Nachfolger
    }

    public T nenneInhalt() {
        return null;
    } 

    public ELEMENT hintenEinfügen(T t){
        return new KNOTEN(t);
    }

    public int gibLänge() {
        return 0; // gibt 0 zurück, weil der Abschluss keinen Inhalt besitzt
    }

    public T entfernenAn(int i) {
       return null; //Abschluss gibt null, falls i zu groß war
    }

    public boolean einfügenAn(T inhalt, int i) {
        return false; //Abschluss gibt false zurück, falls i zu groß war
    }


    public int suchenUndIndexZurückgeben(String info, int i) {
        return -1;
    }

    
}
